package net.sf.basedb.clients.web.extensions.list;

import net.sf.basedb.core.Annotatable;
import net.sf.basedb.core.Type;
import net.sf.basedb.util.listable.SourceItemTransformer;

/**
	Related item column that displays an error message.
	@author nicklas
	@since 3.19.4
*/
public class RelatedItemErrorColumn 
	extends RelatedItemColumn
{

	private final String error;
	
	RelatedItemErrorColumn(int index, Specification spec, RelatedItemHelper helper, String error)
	{
		super(null, index, spec, helper);
		this.error = error;
		setValueType(Type.STRING);
		setFilterable(false);
		setExportable(false);
		setTitle(spec.generateTitle("?"));
		setTooltip(spec.generateTooltip(spec.property));
		setCellClass("error");
	}
	
	@Override
	public Object getValue(RelatedItemHelper helper, Annotatable item, SourceItemTransformer preTransform) 
	{
		return error;
	}

}
