/**
	$Id$

	Copyright (C) 2021 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.web.plugins;

import net.sf.basedb.core.ChangeHistory;
import net.sf.basedb.core.DbControl;

/**
	Data loader implementation for loading the changed item.
	
	@author Nicklas
	@since 3.19
*/
public class ChangeHistoryItemLoader
	implements DataLoader<ChangeHistory>
{
	
	public ChangeHistoryItemLoader()
	{}

	@Override
	public Object getData(DbControl dc, ExportedProperty exportedProperty, ChangeHistory item)
		throws Exception
	{
		return item == null ? null : item.getItem(dc);
	}
}
