/*
  $Id: UserDefaultSettingData.java 6468 2014-06-10 11:27:02Z nicklas $

	Copyright (C) 2005 Johan Enell, Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Jari Häkkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

  BASE is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3
  of the License, or (at your option) any later version.

  BASE is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.data;

/**
	@author nicklas
	@see net.sf.basedb.core.UserDefaultSetting
	@see <a href="../../../../../../html/developer/api/data_api.clients.html">Developer documentation: Client, session and settings</a>
	@hibernate.class table="`UserDefaultSettings`" lazy="false"
	@version 2.0
	@base.modified $Date: 2014-06-10 13:27:02 +0200 (Tue, 10 Jun 2014) $
*/
public class UserDefaultSettingData
	extends SettingData
{
	public UserDefaultSettingData()
	{}

	/** 
		Used by Hibernate to link with setting name.
		@hibernate.property type="string"
		@hibernate.column name="`name`" length="255" not-null="true" unique-key="UserDefaultSetting_uniquesetting"
	*/
	@Override
	public String getName()
	{
		return super.getName();
	}

	private UserData user;
	/**
		Get the user this setting is valid for.
		@hibernate.many-to-one update="false" outer-join="false"
		@hibernate.column name="`user_id`" not-null="true" unique-key="UserDefaultSetting_uniquesetting"
	*/
	public UserData getUser()
	{
		return user;
	}
	public void setUser(UserData user)
	{
		this.user = user;
	}
}
