/**
	$Id: ExtensionsUtil.java 6875 2015-04-20 09:08:18Z nicklas $

	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.extensions;

/**
	Utility class collecting some useful functions related to
	extensions.
	
	@author Nicklas
	@since 3.0
	@base.modified $Date: 2015-04-20 11:08:18 +0200 (Mon, 20 Apr 2015) $
*/
public class ExtensionsUtil
{

	/**
		Get the name of the extension. This will first check
		if {@link Extension#getAbout()} contains a name and use that.
		Otherwise, the id is used as the name.
		@param ext An extension
		@return The name or id of the extension
	*/
	public static String getName(Extension<?> ext)
	{
		String name = null;
		if (ext != null)
		{
			if (ext.getAbout() != null) name = ext.getAbout().getName();
			if (name == null) name = ext.getId();
		}
		return name;
	}
	
	
}
