/**
	$Id: ProtocolParameterValidator.java 4749 2009-02-11 08:49:39Z nicklas $

	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.overview.validator;

import net.sf.basedb.core.AnnotationType;
import net.sf.basedb.core.DbControl;
import net.sf.basedb.util.overview.Fix;
import net.sf.basedb.util.overview.Node;

/**
	Validator implementation for experimental factors. 
	Currently, we are only interested in checking for duplicate 
	names.
	
	@author Nicklas
	@version 2.10
	@base.modified $Date: 2009-02-11 09:49:39 +0100 (on, 11 feb 2009) $
*/
public class ExperimentalFactorValidator
	extends NameableNodeValidator<AnnotationType>
{
	
	public ExperimentalFactorValidator()
	{
		super(null, null);
	}

	@Override
	protected Fix getMissingItemFix(DbControl dc, Node parentNode) 
	{
		return null;
	}
}
