<%-- $Id: index.jsp 7954 2021-05-12 13:27:22Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2021 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Config"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Quota"
	import="net.sf.basedb.core.QuotaType"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.zip.FileUnpacker"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.nio.charset.Charset"
	import="org.json.simple.JSONObject"
	import="org.json.simple.JSONArray"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.FILE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl(":Drag drop file upload");
final int directoryId = Values.getInt(request.getParameter("toDir"));
final int numFiles = Values.getInt(request.getParameter("numFiles"));
try
{
	final Directory dir = Directory.getById(dc, directoryId);
	String numFilesText = numFiles == 1 ? "1 file" : numFiles+" files";
	final String title = HTML.encodeTags("Uploading "+numFilesText+" to " + dir.getName());
	
	JSONArray jsonZipFormats = new JSONArray();
	// Query to retreive FileUnpacker plugins
	final ItemQuery<PluginDefinition> pluginQuery = PluginDefinition.getQuery(null, "net.sf.basedb.util.zip.FileUnpacker");
	pluginQuery.order(Orders.asc(Hql.property("name")));
	pluginQuery.include(Include.MINE, Include.SHARED, Include.IN_PROJECT, Include.OTHERS);
	List<PluginDefinition> plugins = pluginQuery.list(dc);
	for (PluginDefinition plugin : plugins)
	{
		FileUnpacker unpacker = plugin.newInstance(FileUnpacker.class, sc, null, null);
		JSONObject jsonZipFormat = new JSONObject();
		jsonZipFormat.put("id", plugin.getId());
		jsonZipFormat.put("name", unpacker.getFormatName());
		JSONArray jsonExtensions = new JSONArray();
		jsonExtensions.addAll(unpacker.getExtensions());
		jsonZipFormat.put("extensions", jsonExtensions);
		jsonZipFormats.add(jsonZipFormat);
	}
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="~drag_drop_upload.js" styles="progressbar.css">
	
	<style>
	.filelist tr
	{
		border-bottom-width: 1px;
		border-bottom-style: dotted;
	}
	.filelist td
	{
		white-space: nowrap;
		max-width: 45em;
		overflow: hidden;
	}
	.file td
	{
		padding: 1px 0.5em 1px 2px;
	}
	.folder
	{
		font-weight: bold;
	}
	.folder td:before
	{
		content: url('../../images/joust/folder-open.png');
		vertical-align: -25%;
		padding-right: 0.25em;
	}
	.pad
	{
		width: 20px;
	}
	.size, .morefiles
	{
		color: #777777;
		font-style: italic;
	}
	</style>
	</base:head>
	<base:body>
	
	<div id="page-data" class="datacontainer"
		data-directory-id="<%=directoryId%>"
		data-directory-path="<%=HTML.encodeTags(dir.getPath().toString()) %>"
		data-zip-formats="<%=HTML.encodeTags(jsonZipFormats.toJSONString()) %>"
	></div>

	<div id="preUploadForm" class="absolutefull">
		<h1 class="docked" id="mainTitle"><%=title %></h1>
		<form name="upload">
		<div class="content">
			<table class="fullform input100 bottomborder">
			<tr>
				<th>Overwrite existing</th>
				<td>
					<label><input type="radio" name="overwrite" id="overwriteAlways" value="always">Always</label>
					<label><input type="radio" name="overwrite" id="overwriteNever" value="never">Never</label>
					<label><input type="radio" name="overwrite" id="overwriteSize" value="skipOrReplaceSize" checked>If different size</label>
				</td>
				<td></td>
			</tr>
			<tr id="unpackSection" style="display: none;">
				<th class="subprompt"></th>
				<td>
					<label><input type="checkbox" name="unpackCompressed" id="unpackCompressed">Unpack compressed files</label>
				</td>
				<td></td>
			</tr>
			<tr class="big topborder" style="border-top-style: dotted;">
				<th>Files</th>
				<td colspan="2">
					<div id="allFiles" style="height: 18em; max-height: 18em; overflow: auto;">
					<img src="../../images/loading.gif" style="vertical-align: -14px;"><i>Please wait, loading information about dropped files...</i>
					</div>
				</td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="4" name="description" id="description"
						></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</div>
		</form>
		
		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnUpload" image="upload.png" title="Start upload" subclass="disabled" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</div>

	<div id="progressForm" class="absolutefull" style="display: none;">
		<h1 class="docked" id="progressTitle"><%=title %></h1>
		<div class="content">
			<table class="fullcc bg-filled-50 bottomborder"><tr><td>
				<table class="progressbar" style="width: 100%;">
				<tr>
					<td style="width: 2em;"></td>
					<td style="">
						<table class="bar" style="width: 100%;">
						<tr>
							<td style="width: 0%;" class="percentDone" id="percentDone">&nbsp;</td>
							<td style="width: 100%;" class="percentRemain" id="percentRemain">&nbsp;</td>
						</tr>
						</table>
					</td>
					<td style="width: 3em;" class="percentText" id="percentText">0%</td>
					<td style="width: 2em;"></td>
				</tr>
				<tr>
					<td></td>
					<td colspan="2" style="text-align: left;">
						<table class="transfer-info">
						<tr><th>#</th><td><span id="fileCount"></span></td></tr>
						<tr><th>File</th><td><span id="fileName"></span></td></tr>
						<tr><th>Path</th><td><span id="path"></span></td></tr>
						<tr><th>Transferred</th><td><span id="transferredBytes">0 bytes</span> of <span id="totalBytes">unknown</span><span id="skippedBytes"></span></span></td></tr>
						<tr><th>Time</th><td><span id="transferTime">0s</span> <span id="transferRate"></span></td></tr>
						<tr><th>Remain</th><td><span id="remainTime">unknown</span></td></tr>
						<tr><td colspan="2"><span id="message"></span></td></tr>
						</table>
					</td>
					<td></td>
				</tr>
				</table>
			</td>
			</tr>
			</table>
		</div>
		
		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnAbort" image="cancel.png" title="Abort..." />
		</base:buttongroup>
	</div>
	
	<div id="uploadFailed" class="absolutefull" style="display:none;">
		<h1 class="docked" id="failTitle">Upload failed</h1>
		<div class="content bg-filled-50 bottomborder">
			<table style="margin: auto; height: 100%;">
			<tr><td>
				<div class="messagecontainer error" id="failMessage" style="width: 30em; text-align: center;">
				</div>
			</td></tr>
			</table>
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="failClose" title="Close" />
		</base:buttongroup>
	</div>
	
	
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>



