/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/
'use strict';

var Home = function()
{
	var home = {};
	
	/**
		Initialize the page.
	*/
	home.initPage = function()
	{
		// View disk usage details
		Buttons.addClickHandler('btnViewDiskUsage', home.viewDiskUsage);

		// Reload the footnote frame
		top.frames['footnote'].location.reload();
	}
	
	/**
		Set the active project
	*/
	home.setActiveProject = function(event)
	{
		var projectId = Data.int(event.currentTarget, 'project-id');
		Dialogs.openPopup('projects/set_active.jsp?ID=' + App.getSessionId() + '&project_id='+projectId, 'ActivateProject', 300, 200)
	}

	/**
		Go to the disk usage details page for the current user.
	*/
	home.viewDiskUsage = function()
	{
		var url = App.getRoot() + 'admin/diskusage/details/index.jsp?ID='+App.getSessionId();
		url += '&cmd=ViewItem&item_type=USER&item_id='+App.getLoggedInUserId();
		location.href = url;
	}
	
	/**
		Initialize all 'set active' links in the project list.
	*/
	home.initActivateProjectLinks = function(element, autoInit)
	{
		if (autoInit != 'activate-project') return;
		Events.addEventHandler(element, 'click', home.setActiveProject);
	}
	Doc.addElementInitializer(home.initActivateProjectLinks);
	
	return home;
}();

Doc.onLoad(Home.initPage);
