/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2015 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/
'use strict';

var Merge = function()
{
	var merge = {};
	
	merge.initPage = function()
	{
		// Save + Close buttons
		Buttons.addClickHandler('btnSave', merge.save);
		Buttons.addClickHandler('close', App.closeWindow);

		Events.addEventHandler('mergeType', 'change', merge.updateMergeImage);
		Events.addEventHandler('sourceMerge', 'change', merge.updateMergeImage);
		
		merge.updateMergeImage();
	}

	
	merge.validateForm = function()
	{
		var frm = document.forms['merge'];
		if (frm.itemLists.length == 0)
		{
			Forms.showNotification('btnAddItemLists', 'You must select at least one other list');
			return false;
		}
		return true;
	}

	// Submit the form
	merge.save = function()
	{
		var frm = document.forms['merge'];
		if (merge.validateForm())
		{
			Link.exportActions('itemLists');
			frm.submit();
		}
	}
	
	merge.updateMergeImage = function()
	{
		var frm = document.forms['merge'];
		var img = Doc.element('mergeImage');
		var mergeType = frm.mergeType.value;
		var sourceMerge = frm.sourceMerge.value;
		var url = '../../images/set_operations/'+mergeType+'_'+sourceMerge+'.png';
		img.src = url;
	}
	
	return merge;
}();

Doc.onLoad(Merge.initPage);
