<%-- $Id$
	------------------------------------------------------------------
	Copyright (C) 2015 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ItemList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.ITEMLIST;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl(":Merge item lists");
try
{
	String mergeType = request.getParameter("mergeType");
	ItemList itemList = ItemList.getById(dc, itemId);
	cc.setObject("item", itemList);
	String title = "Add/keep/remove items: " + HTML.encodeTags(itemList.getName());
	itemList.checkPermission(Permission.WRITE);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="linkitems-2.js,~merge.js" />
	<base:body>
		<h1><%=title%> <base:help helpid="itemlist.merge" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="merge">
		<input type="hidden" name="cmd" value="MergeItem">

		<div class="content bottomborder">
			<table class="fullform input100">
			<tr>
				<th>This list</th>
				<td><%=HTML.encodeTags(itemList.getName())%></td>
				<td rowspan="2">
					<img id="mergeImage" src="../../images/set_operations/union_union.png" alt="">
				</td>
			</tr>
			<tr class="big">
				<th>What to do</th>
				<td>
					<select name="mergeType" id="mergeType" style="width: 15em;">
						<option value="union" <%="union".equals(mergeType) ? "selected" : ""%>
							>Add items to
						<option value="intersection" <%="intersection".equals(mergeType) ? "selected" : ""%>
							>Keep items in
						<option value="complement" <%="complement".equals(mergeType) ? "selected" : ""%>
							>Remove items from
					</select><br>
					this list that are present in
					<br>
					<select name="sourceMerge" id="sourceMerge" style="width: 15em;">
						<option value="union" <%="intersection".equals(mergeType) ? "" : "selected"%>
							>some of
						<option value="intersection" <%="intersection".equals(mergeType) ? "selected" : ""%>
							>all of
					</select><br>
					the other lists selected below.
					<p>
					After the operation this list will
					contain items from the gray-colored areas in the image.
				</td>
			</tr>
			<tr class="dynamic">
				<th>Other lists</th>
				<td colspan="2">
					<div class="selectionlist">
					<table>
					<tr>
					<td>
						<select name="itemLists" id="itemLists" 
							class="auto-init" data-auto-init="link-container"
							size="10" multiple>
						</select>
					</td>
					<td>
					<td style="vertical-align: top;">
						<base:buttongroup vertical="true">
							<base:button 
								id="btnAddItemLists"
								subclass="leftaligned auto-init"
								data-auto-init="add-link"
								data-list-id="itemLists"
								data-item-type="ITEMLIST"
								data-exclude="<%=itemId %>"
								data-filter="<%="&resetTemporary=1&tmpfilter:INT:memberType="+itemList.getMemberType().getValue()%>"
								style="width: 15em;"
								title="Add&nbsp;item lists&hellip;" 
								tooltip="Add item lists"
							/>
							<base:button 
								id="btnRemoveItemLists"
								subclass="leftaligned auto-init"
								data-auto-init="remove-link"
								data-list-id="itemLists"
								style="width: 15em;"
								title="Remove" 
								tooltip="Remove the selected lists"
							/>
						</base:buttongroup>
					</td>
					</tr>
					</table>
					</div>
				</td>
			</tr>
			</table>
		
		</div>
		</form>
		
		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Ok" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
